
#ifndef Color_h
#define Color_h

#include "trax.hpp"

class Color {
 public:
  Color() {
    R = 1.f;
    G = 1.f;
    B = 1.f;
  }

  Color(const Color& copy) {
    R = copy.R;
    G = copy.G;
    B = copy.B;
    //for(int i=0;i<3;i++)
    //data[i] = copy.data[i];
  }

  Color& operator=(const Color& copy) {
    R = copy.R;
    G = copy.G;
    B = copy.B;
    //for(int i=0;i<3;i++)
    //data[i] = copy.data[i];
    return *this;
  }

  float r() const {
    return R;
  }
  float g() const {
    return G;
  }
  float b() const {
    return B;
  }

  Color(float r, float g, float b) {
    R = r;
    G = g;
    B = b;
  }
  Color operator+(const Color& c) {
    return Color(R + c.R, G+c.G, B+c.B);
  }
  Color& operator+=(const Color& c) {
    R += c.R; G += c.G; B += c.B;
    return *this;
  }
  Color operator-(const Color& c) {
    return Color(R - c.R, G-c.G, B-c.B);
  }
  Color& operator-=(const Color& c) {
    R -= c.R; G -= c.G; B -= c.B;
    return *this;
  }
  Color operator*(const Color& c) {
    return Color(R * c.R, G*c.G, B*c.B);
  }
  Color& operator*=(const Color& c) {
    R *= c.R; G *= c.G; B *= c.B;
    return *this;
  }
  Color operator*(float s) const{
    return Color(R*s, G*s, B*s);
  }
  Color& operator*=(float s) {
    R *= s; G *= s; B *= s;
    return *this;
  }
  Color& operator/=(float s) {
    R /= s; G /= s; B /= s;
    return *this;
  }

  float R, G, B;
};

// load the Kd term from the materail
inline Color loadColorFromMemory(int addr)
{
  return Color(loadf(addr, 4), loadf(addr, 5), loadf(addr, 6));
}

#endif
