
#ifndef HitRecord_h
#define HitRecord_h

#define EPSILON (0.0000001f)

class HitRecord {
 public:
  HitRecord()
    {
      obj_id = 0;
      min = 10000000.f;
      did_hit = false;
      hit_inside = false;
    }

  HitRecord(const float _max) {
    obj_id = 0;
    min = _max;
    did_hit = false;
    hit_inside = false;
  }

  inline bool hit(const float &t, const int &id, const bool &inside = false);

  inline float minT() const {
    return min;
  }
  inline int getID() const {
    return obj_id;
  }
  inline bool didHit() const {
    return did_hit;
  }
  inline bool didHitInside() const {
    return hit_inside;
  }
  
 private:
  float min;
  int obj_id;
  bool did_hit;
  bool hit_inside;
};

inline bool HitRecord::hit(const float &t, const int &id, const bool &inside) {
  if(t > EPSILON && t < min){
    min = t;
    obj_id = id;
    did_hit = true;
    hit_inside = inside;
    return true;
  } else {
    return false;
  }
}


#endif
