
#ifndef PointLight_h
#define PointLight_h

#include "Color.h"

class PointLight{
 public:
  PointLight();
  PointLight(const Vector& position, const Color& color);
  
  float getLight(Color& light_color, Vector& light_direction,
		 const Vector& pos) const;
  
  Vector position;
  Color color;
};

PointLight::PointLight()
{
}

PointLight::PointLight(const Vector& position, const Color& color)
: position(position), color(color)
{
}


float PointLight::getLight(Color& light_color, Vector& light_direction,
			   const Vector& hitpos) const
{
  light_color = color;
  Vector dir = position-hitpos;
  float len = dir.normalize();
  light_direction = dir;
  return len;
}

inline PointLight loadLightFromMemory(int addr)
{
  return PointLight(Vector(loadf(addr, 0), loadf(addr, 1), loadf(addr, 2)), Color(1.f, 1.f, 1.f));
}

#endif

